; Ein Demo-Spiel fr Robs BB-Kurs 2
; www.robsite.de

AppTitle "Alien"	; das Original von Kevin Poole auf www.blitzfantastic.co.uk heisst "Alien Wars",
	 			; ist viel umfangreicher (gezippt 2600kB statt 300kB),
	 			; und ist allgemeiner programmiert.

	 			; Ziel dieser Bearbeitung war, den Code mglichst lesbar zu machen.
	 			; Programmier-Konventionen und Speed-Optimierungs-Empfehlungen
	 			; habe ich deshalb manchmal ignoriert.
	 			;													Jrgen Cassing

	 			; email	englisches Original: kev@blitzfantastic.co.uk (Kevin Poole)
	 			;		diese Eindeutschung: jcassing@talknet.de (Jrgen Cassing)


; einige Konstanten
;***************************************************************

Const breit=1024	; n a t  r l i c h
Const hoch = 768	;   n d e r b a r

Const mg	= 15		; 3  S c h u s s  i s t  S t a n d a r d , aber wer schummelt nicht gern ...

Const alienanzahl=18,drehanzahl=64,maxlevel=9
Const spread=34			; sternen-spread
Const speed#=0.6		
Const leer=57, rechts=205, links=203		


; globale Variablen, die auch in Funktionen funktionieren.
;***************************************************************

Global spielstatus,spieltimer,levelname$,alienspeed,xx,yy
Global aliennr,flugnr,flug_timer,kugelnr,spielernr
Global insektx#,insektxs#,insektys#,insektspeed#,insektphase#,insektxgross#,insektygross#,hinrichtung#,gegenrichtung
Global Spielerbild,sternebild,kugelmax
Global miniship,tmpbild,level
Global extrasnd,aliensnd,schutzsnd,pickupsnd;,echosnd
Global geschossnr=0,geschossab,keytimer,tbl,keywarten,shutdown=False
Global alpha$=" .ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789"

Global Spieler,spielopt,titelbild,Kugelbild,Bombebild,alienschutz,untertasse,fallbild,ichschutz
Global schlangelinks,schlangerechts,exploanim,alienschiffe

Global titelsound,titelsnd,alienextrasnd,soundschutz,alienexplo,soundpickup;,soundecho

; fr die Rotation der Alienschiffe
Dim aliendreh(alienanzahl,drehanzahl)
Dim alienbild(alienanzahl)
Dim geschossbild(drehanzahl)

; 10 hiscore slots.
Dim ptabelle.highscoretabelle(10)


; fr high score tabelle
Global alphalang=Len(alpha$)
Global buchstabeweiter=3
Dim buchstabe(alphalang,2)


; eine Menge von Types
;***************************************************************

Type highscoretabelle
 Field name$
 Field punkte
End Type

Type sterntype
 Field x#,y#,z#,sx#,sy#
End Type

	For d=1 To 200
		st.sterntype=New sterntype
	Next

Type Bombe
 Field x#,y#,xs#,ys#
End Type

Type Kugel
 Field x,y
End Type

Type Explosion
 Field x,y,frame
End Type

Type alien
 Field bild,schalen
 Field x#,y#,dreh,status
 Field f_x#,f_y#
 Field ziel_y#,ziel_dreh,dreh_schritt,bombzahl,suchmich
End Type

Type Spieler
 Field frame,x,y,status,leben
 Field strg,bang,punkte,schutz
 Field speed,geschoss
End Type

Type untertasse
 Field x,y,richtung,speed
End Type

Type pickup; werden vom alien-extraschiff fallengelassen
 Field x,y,item	; item = 1 2 3 4 5
End Type

Type geschoss
 Field x,y
 Field zielx,ziely
 Field gegenkathete#,ankathete#
 Field winkel,speed,dreh
End Type


; d a s    H a u p t p r o g r a m m
;***************************************************************


; Grafik-modus
Graphics breit,hoch,16,1
SetBuffer BackBuffer()

GRAFIKLADEN()

SOUNDLADEN()

ALIENSSCHNAPPEN()

HIGHSCOREDATEILADEN()


spielstatus=0; = warten auf spielstart
spieltimer=0
zeit=MilliSecs()


Repeat; - - - - - - - - - d i e   H a u p t s c h l e i f e

 Cls

 jetzt=MilliSecs()
 zeitraum=jetzt-zeit
 If zeitraum>25		;runter auf 40 FPS (1000/40=25 millisecs)
	affe=zeitraum/25
	For k=1 To affe
		SPIELNEU()
	Next
		zeit=zeit+affe*25
 Else
		SPIELNEU()
		zeit=jetzt
 EndIf

 STERNE()
 SPIELMALEN()

 Flip

Until KeyHit(1); - - - - - - - - - - - - - - - - - - - - - -

End





;***************************BB-Hilfe:****************************************
;* F u n k t i o n e n		"most professional programmers loathe and hate <-- verabscheuen und hassen
;*							the use of 'branching' commands like Goto/Gosub"*
;****************************************************************************






Function GESCHOSSNEU(g.geschoss);*******************************

 For a.Alien=Each Alien
	If geschossab=1
		g\zielx = a\x
		g\ziely = a\y
		a\suchmich=1
	Else
		a\suchmich=0

		If g\zielx<>a\x Or g\ziely<>a\y
			If aliennr>0
				geschossab=1
				Return	
			Else
				Delete g
				Return
			EndIf
		EndIf
	EndIf
 Next

 g\gegenkathete = g\y - g\ziely
 g\ankathete	= g\zielx - g\x

 If g\ankathete <> 0
	;tan zwischen -90 und 90, darum quadrant wichtig
	g\winkel = ATan(g\gegenkathete/g\ankathete)
	If g\zielx < g\x
		If g\ziely < g\y Then	g\winkel=g\winkel+180	Else	g\winkel=g\winkel+180
	Else
		If g\ziely < g\y Then							Else	g\winkel=g\winkel+360
	EndIf
 Else
	g\winkel = 0
 EndIf

 g\x=g\x+Cos(g\winkel)*g\speed
 g\y=g\y-Sin(g\winkel)*g\speed

 g\dreh=g\dreh+1

 If g\dreh<0 			Then g\dreh=drehanzahl-1
 If g\dreh>drehanzahl-1 Then g\dreh=0

 For a.Alien=Each Alien
 If a\suchmich=1

 If ImagesOverlap(Kugelbild,g\x,g\y,aliendreh(a\bild,a\dreh*drehanzahl/360 ),a\x,a\y)

 If a\status=1:			punkte=25
 Else If a\status=2:	punkte=50
 Else:					punkte=100
 EndIf
	 		
 PUNKTEADDIEREN( First Spieler,punkte )
 EXPLOSIONERZEUGEN( a\x,a\y )
 If a\status<>1 flugnr=flugnr-1
 aliennr=aliennr-1
 Delete a
 geschossnr=0
 geschossab=0
 Delete g
 Return
EndIf

EndIf
Next

End Function





Function GESCHOSSMALEN(g.geschoss);*****************************

 DrawImage geschossbild(g\dreh),g\x,g\y
End Function





Function PICKUPSSAMMELN(s.Spieler,item);************************

 Select item
	 Case 1:	s\leben		=s\leben+1
	 Case 2:	s\schutz	=1
	 Case 3:	s\geschoss	=1
	 Case 4:	s\speed		=6
	 Case 5:	kugelmax	=mg+1
 End Select
End Function




Function FALLBILDERZEUGEN(u.untertasse,items);******************

 fallbilder.pickup=New pickup
 fallbilder\x=u\x
 fallbilder\y=u\y
 fallbilder\item=items

End Function





Function FALLBILDMALEN(fallbilder.pickup);**********************

 DrawImage fallbild,fallbilder\x,fallbilder\y,fallbilder\item
End Function





Function FALLBILDNEU(fallbilder.pickup);************************

 If fallbilder\y < hoch+ImageHeight(fallbild) Then fallbilder\y=fallbilder\y+4	Else Delete fallbilder

End Function





Function SCHUTZMALEN(a.Alien);**********************************

 DrawImage alienschutz,a\x,a\y
End Function





Function EXTRAMALEN(u.untertasse);******************************

 DrawImage untertasse,u\x,u\y
End Function





Function EXTRAERZEUGEN(richtung);*******************************

 u.untertasse=New untertasse

 If richtung=0 	Then:	u\x=0:		u\y=26:	u\richtung=richtung:	u\speed=2
	 			Else:	u\x=breit:	u\y=26:	u\richtung=richtung:	u\speed=2
 EndIf

 SoundVolume alienextrasnd,.25
 LoopSound alienextrasnd
 extrasnd=PlaySound(alienextrasnd)

End Function




Function EXTRANEU(u.untertasse);********************************

 If aliennr>0
	If u\richtung=1 Then: u\x=u\x-u\speed:	If u\x <     0-ImageWidth(untertasse) Then	StopChannel extrasnd:		Delete u
					Else: u\x=u\x+u\speed:	If u\x > breit+ImageWidth(untertasse) Then	StopChannel extrasnd:		Delete u
	EndIf
 Else
	Delete u
 EndIf	

End Function





Function PUNKTEADDIEREN( s.Spieler,punkte );********************

 t=s\punkte/5000
 s\punkte=s\punkte+punkte
 If s\punkte/5000<>t Then s\leben=s\leben+1
End Function





Function EXPLOSIONNEU( e.Explosion );***************************

 e\frame=e\frame+1
 If e\frame=10 Then Delete e	
End Function





Function EXPLOSIONMALEN( e.Explosion );*************************

 If e\frame<0 Then	StopChannel aliensnd:	Return
 DrawImage exploanim,e\x,e\y,e\frame/3
End Function





Function EXPLOSIONERZEUGEN( x,y,frame=0 );**********************

 e.Explosion=New Explosion
 e\x=x:e\y=y:e\frame=frame
 SoundVolume alienexplo,.25
 aliensnd=PlaySound(alienexplo)	
End Function






Function SPIELERERZEUGEN( strg );*******************************

 s.Spieler=New Spieler
 s\leben	=3
 s\speed	=4
 s\strg	=strg
 s\frame	=2
 SPIELERZURUCK( s )
 spielernr=spielernr+1
 kugelmax=mg;3
End Function





Function SPIELERZURUCK( s.Spieler );****************************

 s\x		=breit/2
 s\y		=hoch-20
 s\status	=1
 kugelmax	=mg;3
 s\geschoss	=0
 geschossnr	=0
 geschossab	=0
End Function





Function SPIELERNEU( s.Spieler );*******************************

 If s\status<>1 Then Return


 If		 KeyDown(links):		If s\x>16 		Then s\x=s\x-s\speed:s\frame=1
 Else If KeyDown(rechts):		If s\x<breit-16 Then s\x=s\x+s\speed:s\frame=4
 EndIf

 If Not KeyDown(links) Or KeyDown(rechts) Then	s\frame=2

 If spielstatus<>2 Then Return

 keywarten=keywarten+1
 If keywarten=>5;15
	If KeyDown(leer) And kugelnr<kugelmax
		b.Kugel=New Kugel
		b\x=s\x
		b\y=s\y-16
		kugelnr=kugelnr+1
;		If kugelnr=kugelmax-1 Then echosnd=PlaySound(soundecho)
		keywarten=0
	EndIf
 EndIf

 If KeyDown(leer) And s\geschoss=1 And geschossnr=0
	g.geschoss=New geschoss
	g\x=s\x
	g\y=s\y-16
	g\speed=3
	geschossnr=geschossnr+1
	geschossab=1
 End If

 tot=False	
 For a.Alien=Each Alien
	If ImagesOverlap( Spieler,s\x,s\y,aliendreh( a\bild,a\dreh*drehanzahl/360 ),a\x,a\y )

		If s\schutz=1 Then	Return
		tot=True
		Exit
	EndIf
 Next

 For bb.Bombe=Each Bombe
	If ImagesOverlap( Spieler,s\x,s\y,Bombebild,bb\x,bb\y )

		If s\schutz=1

			DrawImage alienschutz,s\x,s\y
			Delete bb
			Return
		EndIf
		tot=True
		Exit
	EndIf
 Next

 If Not tot Then Return

 For k=-105 To 0 Step 15
	 EXPLOSIONERZEUGEN( s\x+Rnd(-10,10),s\y+Rnd(-10,10),k )
 Next

 s\bang=1
 s\status=2
 s\leben=s\leben-1
 spielstatus=3

End Function





Function SPIELERMALEN( s.Spieler );*****************************

 Color 255,255,255
 Text breit/2,4,s\punkte

 For k=1 To s\leben
	DrawImage miniship,k*16+8,hoch-8
 Next

 If s\status=1
 For fallbilder.pickup=Each pickup
	If ImagesCollide(Spieler,s\x,s\y,s\frame,fallbild,fallbilder\x,fallbilder\y,fallbilder\item)
		pickupsnd=PlaySound(soundpickup)
		pickup=fallbilder\item
		Delete fallbilder
		PICKUPSSAMMELN(s.Spieler,pickup)
	EndIf
 Next


 If s\schutz=1 Then	DrawImage ichschutz,s\x,s\y

 DrawImage Spieler,s\x,s\y,s\frame	

 Return

 EndIf

 s\bang=s\bang+8

End Function





Function BOMBEWERFEN( a.Alien );********************************

 If a\bombzahl=0 Then a\bombzahl=Rnd(50,100)
 a\bombzahl=a\bombzahl-1
 If a\bombzahl>0 Then Return
 s.Spieler=First Spieler
 If s=Null Then Return
 b.Bombe=New Bombe
 b\x=a\x
 b\y=a\y
 If a\x<s\x Then b\xs=1 Else b\xs=-1
 b\ys=4
End Function





Function BOMBENEU( b.Bombe );***********************************

 b\x=b\x+b\xs
 b\y=b\y+b\ys
 If b\y>hoch Then Delete b
End Function






Function BOMBEMALEN( b.Bombe );*********************************

 DrawImage Bombebild,b\x,b\y
End Function






Function KUGELMALEN( b.Kugel );*********************************

 DrawImage Kugelbild,b\x,b\y
End Function





Function KUGELNEU( b.Kugel );***********************************

 b\y=b\y-5

 For u.untertasse=Each untertasse
	If ImagesOverlap( Kugelbild,b\x,b\y,untertasse,u\x,u\y)
		punkte=1000
		PUNKTEADDIEREN( First Spieler,punkte )
		EXPLOSIONERZEUGEN( u\x,u\y)
		FALLBILDERZEUGEN(u.untertasse,Rnd(1,5))
		Delete u
		StopChannel extrasnd
	EndIf
 Next
	
 For a.Alien=Each Alien
	If ImagesOverlap( Kugelbild,b\x,b\y,aliendreh(a\bild,a\dreh*drehanzahl/360 ),a\x,a\y )

		If a\schalen>0
			schutzsnd=PlaySound(soundschutz)
			a\schalen=a\schalen-1
			
			SCHUTZMALEN(a.Alien)

			a\y=a\y-6
			Delete b:kugelnr=kugelnr-1
			Return
		Else
			If a\status=1:		punkte=25
			Else If a\status=2:	punkte=50
					Else:		punkte=100
			EndIf
			
			PUNKTEADDIEREN( First Spieler,punkte )
			EXPLOSIONERZEUGEN( a\x,a\y )
			Delete b:kugelnr=kugelnr-1
			If a\status<>1 flugnr=flugnr-1
			aliennr=aliennr-1
			Delete a
			Return
		EndIf
	EndIf

 Next

 If b\y>0 Then Return
 Delete b
 kugelnr=kugelnr-1

End Function





Function ALIENSSCHNAPPEN();*************************************

 ; minibild konstruieren
 miniship=CreateImage(32,32)
 SetBuffer ImageBuffer(miniship)
 DrawImage Spieler,38/2,28/2,2
 ScaleImage miniship,.4,.4

 For f=0 To alienanzahl-1

	alienbild(f)=CreateImage(38,28)	
	SetBuffer ImageBuffer(alienbild(f))
	DrawImage alienschiffe,38/2,28/2,f

	SetBuffer FrontBuffer()

	DrawImage titelbild,breit/2,hoch/2

	For k=0 To drehanzahl-1
		aliendreh(f,k)=CopyImage(alienbild(f))
		RotateImage aliendreh(f,k),k*360/drehanzahl
	Next

 Next

 geschoss0=CreateImage(15,17)
 SetBuffer ImageBuffer(geschoss0)
 DrawImage Kugelbild,15/2,17/2,1

 For k=0 To drehanzahl-1
	geschossbild(k)=CopyImage(geschoss0)
	RotateImage geschossbild(k),k*360/drehanzahl
 Next

 SetBuffer BackBuffer()

End Function





Function SPIELMALEN();******************************************

 done_exit=False

 For a.Alien=Each Alien
	ALIENMALEN( a )
 Next

 For s.Spieler=Each Spieler
	SPIELERMALEN( s )
 Next

 For bb.Bombe=Each Bombe
	BOMBEMALEN( bb )
 Next


 For b.Kugel=Each Kugel
	KUGELMALEN( b )
 Next

 For g.geschoss=Each geschoss
	GESCHOSSMALEN( g.geschoss )
 Next

 For e.Explosion=Each Explosion
	EXPLOSIONMALEN( e )
 Next

 For u.untertasse=Each untertasse
	EXTRAMALEN(u.untertasse)
 Next

 For fallbilder.pickup=Each pickup
	FALLBILDMALEN(fallbilder.pickup)
 Next

 If spielstatus=0 Then	

	DrawImage titelbild,breit/2,hoch/4-20
	DrawImage spielopt,breit/2,hoch/2-10						 ,0
	DrawImage spielopt,breit/2,hoch/2+ImageHeight(spielopt)*1+20,1
	DrawImage spielopt,breit/2,hoch/2+ImageHeight(spielopt)*2+40,2

	xx =breit/2-150
	xxx=breit/2+150

		
	If Not KeyHit(208); unten
		If yy=0 								Then	yy=hoch/2							Else	yy=yy
	Else
		If yy<hoch/2+ImageHeight(spielopt)*2+40 Then	yy=yy+ImageHeight(spielopt)*1+20	Else	yy=hoch/2	
	EndIf
		
	If KeyHit(200)	; oben
		If yy>hoch/2 							Then	yy=yy-ImageHeight(spielopt)*1-20	Else	yy=hoch/2+ImageHeight(spielopt)*2+40
	EndIf
		
	If KeyHit(28)	; enter

		Select yy
			
			Case hoch/2:							SPIELNEUSTART()
			Case hoch/2+ImageHeight(spielopt)*1+20:	HIGHSCORETABELLE(0,0)
			Case hoch/2+ImageHeight(spielopt)*2+40:	shutdown=True:	SPIELENDE():	End
		End Select

	EndIf
			
	DrawImage schlangelinks,xx,yy-5
	DrawImage schlangerechts,xxx,yy-5

 End If

End Function





Function HIGHSCORESORTIEREN(hiscore);***************************

 If hiscore > ptabelle(9)\punkte

	ptabelle(10)\punkte=hiscore

	For bub1=0 To 10
		zahl=0
		For bub2=0 To 9
			tempa=ptabelle(zahl)\punkte	
			tempb=ptabelle(zahl+1)\punkte

				If tempb>tempa
				tempna$=ptabelle(zahl)\name$
				tempnb$=ptabelle(zahl+1)\name$
				ptabelle(zahl)\name$=tempnb$
				ptabelle(zahl+1)\name$=tempna$
				ptabelle(zahl)\punkte=tempb
				ptabelle(zahl+1)\punkte=tempa			
			EndIf
			zahl = zahl + 1
		Next	
	Next
 EndIf

End Function






Function HIGHSCORETABELLE(tabelle_pos,hiscore);*****************

 done_exit=False

 While done_exit=False

	Cls
	STERNE()

	; schleife durch das punkte array.
	For zahl =0 To 9
		Color 0,0,255:	Text breit/2-55,hoch/2-120+zahl*24,ptabelle(zahl)\name$ ,1,1
						Text breit/2+55,hoch/2-120+zahl*24,ptabelle(zahl)\punkte,1,1	
	Next

	If Len(ptabelle(tabelle_pos)\name$)<3

		; um jeden buchstabe nach li oder re zu schieben
		Color 255,0,0: For loop=1 To alphalang
						Text buchstabe(loop,0),buchstabe(loop,1),Chr$(buchstabe(loop,2))				
					   Next

		Color 255,255,0:Oval buchstabe(buchstabeweiter,0)-4,buchstabe(buchstabeweiter,1)-2,16,16,0

		Color 0,0,255:	Text breit/2,30,"High Score Tabelle",1,1
						Text breit/2,hoch-16,"Esc = Exit",1,1


		If KeyHit(28)
			If Len(ptabelle(tabelle_pos)\name$)<3
				ptabelle(tabelle_pos)\name$=ptabelle(tabelle_pos)\name$+Chr$(buchstabe(buchstabeweiter,2))
				Text breit/4-55,hoch/2-120+tabelle_pos*24,ptabelle(tabelle_pos)\name$,1,1
			EndIf
		EndIf


		If KeyDown(links) 				
			If keytimer>10
				If buchstabeweiter=alphalang Then	buchstabeweiter=1 Else buchstabeweiter=buchstabeweiter+1
				keytimer=0
			EndIf
		EndIf


		If KeyDown(rechts)
			If keytimer>10
				If buchstabeweiter=1	Then buchstabeweiter=alphalang Else buchstabeweiter=buchstabeweiter-1
				keytimer=0
			EndIf
		EndIf

		For zahl = 0 To 9
			Text breit/2-55,hoch/2-120+zahl*24,ptabelle(zahl)\name$,1,1
			Text breit/2+55,hoch/2-120+zahl*24,ptabelle(zahl)\punkte,1,1	
		Next

		keytimer=keytimer+1
		
	Else
		Text breit/2,	30	,"High Score",1,1
		Text breit/2,hoch-16,"Esc = Exit",1,1			
	EndIf


	If KeyHit(1)

		If ptabelle(tabelle_pos)\name$="" 		Then ptabelle(tabelle_pos)\name$="..."
		If Len(ptabelle(tabelle_pos)\name$)<3 	Then ptabelle(tabelle_pos)\name$=LSet$(ptabelle(tabelle_pos)\name$,3)	
		done_exit=True
	EndIf

	Flip

 Wend

 SetBuffer BackBuffer()

 If tabelle_pos=>0

	tbl=WriteFile("highscore.tbl")

	XORKEY=1111
	
	For zahl=0 To 9
		For loop=1 To Len(ptabelle(zahl)\name$)
			tmp_var=Asc(Mid$(ptabelle(zahl)\name$,loop,1))
			geheimname=tmp_var Xor XORKEY
			WriteInt tbl,geheimname
		Next

		geheimpunkte=ptabelle(zahl)\punkte Xor XORKEY
		WriteInt tbl,geheimpunkte
		
	Next

	CloseFile tbl

 EndIf

End Function





Function FORMATIONNEU();****************************************

 insektphase=(insektphase+insektspeed)Mod 360
 t#=Sin( insektphase )*.5+.5
 insektxs=t*insektxgross+1
 insektys=t*insektygross+1

 If spielstatus<>1 Then insektx=insektx+hinrichtung

End Function







Function FLUGTIMERNEU();****************************************

 If aliennr>3
	If flug_timer=0 Then flug_timer=600
	flug_timer=flug_timer-1
	If flug_timer>120 Then Return
	If flug_timer Mod 30<>0 Then Return
 EndIf

 n=Rnd( aliennr-flugnr )

 For a.Alien=Each Alien
	If a\status=1
		If n=0
			a\ziel_y=a\y
			a\dreh_schritt=3:If Rnd(1)<.5 Then a\dreh_schritt=-3
			flugnr=flugnr+1
			a\status=2
			Return
		EndIf
		n=n-1
	EndIf

 ;	If flugnr>2
 ;		SaveBuffer(BackBuffer(),"snapshot.bmp")
 ;	EndIf

 Next
End Function





Function SPIELNEU();********************************************

 Select spielstatus
 Case 0:		spieltimer=spieltimer+1
	 		;If KeyHit(leer) Then SPIELNEUSTART()
 Case 1:		spieltimer=spieltimer+1
			If spieltimer=150 Then spielstatus=2;150
			FORMATIONNEU()
 Case 2:		FLUGTIMERNEU()
			FORMATIONNEU()

	If aliennr>0 And spieltimer=1000  ;1000

		For s.Spieler=Each Spieler
			
			If s\schutz	=1 Then s\schutz=0
			If s\speed	>4 Then s\speed	=4
		Next

		EXTRAERZEUGEN(Rnd(1))
		spielstatus=2
		spieltimer=0
	Else

		If aliennr=0
			
			For g.geschoss=Each geschoss
				Delete g
			Next

			For u.untertasse=Each untertasse
				Delete u
				StopChannel extrasnd
			Next
		EndIf
		spieltimer=spieltimer+1
	EndIf

	If aliennr=0
		If level<=maxlevel-1

			For b.Kugel= Each Kugel
				Delete b:kugelnr=kugelnr-1
			Next

			LEVELSTARTEN()
			level=level+1
		Else

			SPIELENDE()
			Return
		EndIf
	EndIf

 Case 3:		FORMATIONNEU()
	If flugnr=0 And First Explosion=Null
		s.Spieler=First Spieler
		If s\leben>0
			SPIELERZURUCK( s )
			spielstatus=2
			FlushKeys()
		Else
			SPIELENDE()
		EndIf
	EndIf

 Case 4:		FLUGTIMERNEU()
			FORMATIONNEU()
			spieltimer=spieltimer+1
 End Select

 gegenrichtung=False
 For a.Alien=Each Alien
	ALIENBEWEGEN(a)
 Next
 If gegenrichtung Then hinrichtung=-hinrichtung

 For s.Spieler=Each Spieler
	SPIELERNEU( s )
 Next


 For bb.Bombe=Each Bombe
	BOMBENEU( bb )
 Next

 For b.Kugel=Each Kugel
	KUGELNEU( b )
 Next

 For g.geschoss=Each geschoss
	GESCHOSSNEU(g.geschoss)
 Next

 For e.Explosion=Each Explosion
	EXPLOSIONNEU( e )
 Next

 For u.untertasse=Each untertasse
	EXTRANEU(u.untertasse)
 Next

 For fallbilder.pickup=Each pickup
	FALLBILDNEU(fallbilder.pickup)
 Next

End Function





Function SPIELNEUSTART();***************************************

 level=0
 kugelnr=0
 aliennr=0
 flugnr=0
 spielstatus=0
 spielernr=0
 alienspeed=3

 SPIELERERZEUGEN(1)

 Restore .levels

 LEVELSTARTEN()

 FlushKeys()

End Function






Function ALIENMALEN( a.Alien );*********************************

 DrawImage aliendreh(a\bild, a\dreh*drehanzahl/360 ),a\x,a\y	
End Function





Function ALIENBEWEGEN( a.Alien );*******************************

 Select a\status
 Case 1
	If a\dreh<>0
		If a\dreh>180 				Then a\dreh=a\dreh+6 Else a\dreh=a\dreh-6
		If a\dreh<0 Or a\dreh>=360 	Then a\dreh=0
	EndIf
	dx=insektx+a\f_x*insektxs - a\x
	dy=104+a\f_y*insektys - a\y
	If dx<-alienspeed Then dx=-alienspeed Else If dx>alienspeed Then dx=alienspeed
	If dy<-alienspeed Then dy=-alienspeed Else If dy>alienspeed Then dy=alienspeed
	a\x=a\x+dx
	a\y=a\y+dy
	If hinrichtung<0 And a\x<16			Then gegenrichtung=True
	If hinrichtung>0 And a\x>breit-16	Then gegenrichtung=True
 Case 2
	a\dreh=a\dreh+a\dreh_schritt
	If a\dreh<0 Then a\dreh=a\dreh+360 Else If a\dreh>=360 Then a\dreh=a\dreh-360

	If a\dreh<90 Or a\dreh>270
		a\ziel_dreh=Rnd(180-40,180+40)
		a\ziel_y=a\ziel_y+Rnd( 100,300 )
		a\status=3
	EndIf

	a\x=a\x+Cos( a\dreh-90 )*alienspeed
	a\y=a\y+Sin( a\dreh-90 )*alienspeed

	BOMBEWERFEN( a )

 Case 3
	dr=a\dreh-a\ziel_dreh
	If Abs(dr)>Abs(a\dreh_schritt)
		a\dreh=a\dreh+a\dreh_schritt
		If a\dreh<0 Then a\dreh=a\dreh+360 Else If a\dreh>=360 Then a\dreh=a\dreh-360
	EndIf
	a\x=a\x+Cos( a\dreh-90 )*alienspeed
	a\y=a\y+Sin( a\dreh-90 )*alienspeed
	If a\y>hoch
		a\x=Rnd(breit/2)+breit/4:a\y=0
		flugnr=flugnr-1
		a\status=1
	Else If a\y>a\ziel_y
		a\dreh_schritt=-a\dreh_schritt
		a\status=2
	EndIf

	BOMBEWERFEN( a )
 End Select

End Function




Function LEVELSTARTEN();****************************************

 Read levelname$
 If levelname$=""
	Restore .levels
	Read levelname$
	alienspeed=alienspeed+1
	If alienspeed>6 Then alienspeed=6
 EndIf

 insektx			=breit/2
;	insekty			=104
 insektphase		=0
 hinrichtung	=1

 Read insektspeed,insektxgross,insektygross

 Repeat

	Read x
	If x=999 Then Exit
	Read y,affe,bild_nr,doof
	For k=1 To affe
		a.Alien=New Alien
		a\bild	=bild_nr
		a\schalen	=doof
		a\x		=insektx
		a\y		=104
		a\dreh	=0
		a\status=1
		a\f_x	=x*34
		a\f_y	=y*24
		x=x+1
	Next

	aliennr=aliennr+affe

 Forever

 spielstatus=1
 spieltimer=0

End Function





Function STERNE();**********************************************

 For st.sterntype = Each sterntype

	neustern=False

	; sternenupdate beschleunigen
	If st\z#<speed# 			Then neustern=True

	; sternenbewegung updaten
	st\z#=st\z#-speed#
 		t# = st\x#*spread : st\sx#=t#/(  st\z#) + breit/2
 		t# = st\y#*spread : st\sy#=t#/(4+st\z#) + hoch/2
 
	; ist der stern auf dem schirm?
	If st\sx#<0 Or st\sx#>breit Then neustern=True

	; ist der stern auf dem schirm?
	If st\sy#<0 Or st\sy#>hoch	Then neustern=True

	; ein neuer stern	
	If neustern=True
 		st\z# = Rnd(255)
 		st\x# = Rnd(2000)-1000
 		st\y# = Rnd(2000)-1000
	 EndIf

	;  sterne malen
	Color 255-st\z#,255-st\z#,255-st\z#
	Plot st\sx#,st\sy
 Next
End Function





Function SPIELENDE();*******************************************

 SetBuffer BackBuffer()

 If shutdown=False	
	buchstabeweiter=3

	For k#=0 To 359 Step 5.50;5.60
		pos=pos+1
		x#=Cos(k)*200
		y#=Sin(k)*200
		buchstabe(pos,0)=breit/2+x
		buchstabe(pos,1)=hoch/2+y
	Next

	For loop=1 To Len(alpha$)
		buchstaben$=Mid$(alpha$,loop,1)
		buchstabe(loop,2)=Asc(buchstaben$)
	Next
 EndIf

 ; sind punkte hoch genug fr die high score tabelle?
 For s.Spieler=Each Spieler

	HIGHSCORESORTIEREN(s\punkte)

	; loop durch das punkte array.
	For zahl = 0 To 9
		If s\punkte>=ptabelle(zahl)\punkte
			ptabelle(zahl)\name$="";hier kommt der neu name rein
			ptabelle(zahl)\punkte=s\punkte
			HIGHSCORETABELLE(zahl,s\punkte)
			s\punkte=0
		EndIf
	Next

 Next

 Delete Each Spieler
 Delete Each Kugel
 Delete Each Alien
 Delete Each Bombe

 spielstatus	=0
 spieltimer	=0
 level		=0

 FlushKeys()
	
End Function


Function GRAFIKLADEN();*****************************************

 ; die bilder laden
 AutoMidHandle True; gilt fr alle bilder
 Spieler		=LoadAnimImage("ichschiff.bmp",32,32,0,5)
 spielopt	=LoadAnimImage("spieloptionen.bmp",210,50,0,3)
 titelbild	=LoadImage("alien.bmp")
 Kugelbild	=LoadAnimImage( "kugel.bmp",15,17,0,5 )
 Bombebild	=LoadImage( "bombe.bmp" )
 alienschutz	=LoadImage("alienschutz.bmp")
 untertasse	=LoadImage("untertasse.bmp")
 fallbild	=LoadAnimImage("fallbilder.bmp",32,32,0,6)
 ichschutz	=LoadImage("ichschutz.bmp")
 schlangelinks =LoadImage("pfeil.bmp")
 schlangerechts=CopyImage(schlangelinks):RotateImage schlangerechts,180 ;360
 exploanim	=LoadAnimImage( "explo.bmp",60,48,0,10 )
 alienschiffe=LoadAnimImage( "alienschiffe.bmp",38,28,0,alienanzahl)

End Function



Function SOUNDLADEN();*********************************

 ;die sounds laden
 titelsound	=LoadSound( "alien.mp3")
 alienextrasnd=LoadSound("alienextra.wav")
 soundschutz	=LoadSound("schutz.wav")
; soundecho	=LoadSound("echo.wav")
 alienexplo	=LoadSound("explo.wav")
 soundpickup	=LoadSound("powerup.wav")

 LoopSound titelsound
 titelsnd	=PlaySound(titelsound)

End Function




Function HIGHSCOREDATEILADEN();*********************************

 tbl=ReadFile("highscore.tbl")
 If tbl=False

	Restore highscoredata

	For zahl =0 To 10

		ptabelle(zahl) = New highscoretabelle
	
		Read namedata$,highscoredata
		ptabelle(zahl)\name$	=namedata$
		ptabelle(zahl)\punkte	=highscoredata
	Next

 Else

	XORKEY=1111; verschlsselt mit der zahl 1111 (z.B.)

	For zahl=0 To 10
		ptabelle(zahl) = New highscoretabelle

		For loop=1 To 3
			geheimname=ReadInt(tbl)
			geheimnamen$=Chr$(geheimname Xor XORKEY)
			ptabelle(zahl)\name$=ptabelle(zahl)\name$+geheimnamen$
		Next

		geheimpunkte=ReadInt(tbl)
		ptabelle(zahl)\punkte=geheimpunkte Xor XORKEY
		
	Next

	CloseFile tbl

 EndIf

End Function






.levels
; -			    = links
; |  -			= zeilen-nr
; |  |  -		= anzahl alienschiffe
; |  |  |  -	= das bild der aliens
; |  |  |  |  -	= schalen: zahl der treffer, die das alien abkann.

Data "LEVEL 1"		;levelname$
Data  1,.25,.25		;insektspeed,insektxgross,insektygross
Data -1,-2,1,3,0	;x,y,affe,bild_nr,schalen
Data -2,-1,3,3,0
Data -3, 0,5,4,0
Data -4, 1,7,4,1
Data -3, 2,5,5,0
Data -2, 3,3,5,0
Data -1, 4,1,7,0
Data 999

Data "LEVEL 2"
Data 1,.25,.25
Data -1,-2,2,5,0
Data -1,-1,2,7,0
Data -1,0,2,6,0
Data -4,1,8,5,2
Data -4,2,8,4,2
Data -1,3,2,3,0
Data -1,4,2,2,0
Data -1,5,2,1,0
Data 999

Data "LEVEL 3"
Data 1,.25,.25
Data 0,-2,1,7,1
Data -1,-1,3,11,0
Data -2,0,5,13,0
Data -3,1,7,12,1
Data -4,2,9,11,0
Data -5,3,11,7,3
Data 999

Data "LEVEL 4"
Data 1,.25,.25
Data -7,-3,4,8,5
Data -7,-2,4,7,4
Data -7,-1,4,3,3
Data 4,-3,4,12,0
Data 4,-2,4,3,0
Data 4,-1,4,5,0
Data -4,0,9,1,1
Data -5,1,11,2,2
Data -4,2,9,3,3
Data 999

Data "LEVEL 5"
Data 1,.25,.25
Data -2,-3,5,10,0
Data -2,-2,5,15,1
Data -2,-1,5,10,0
Data -6,0,5,15,1
Data -6,1,5,16,2
Data -6,2,5,6,1
Data 2,0,5,2,0
Data 2,1,5,11,3
Data 2,2,5,1,0
Data -3,3,7,13,0
Data -2,4,5,12,0
Data -1,5,3,10,3
Data 0,6,1,11,0
Data 999

Data "LEVEL 6"
Data 1,.25,.25
Data -2,-3,5,14,3
Data -2,-2,5,10,1
Data -2,-1,5,9,5
Data -3,0,7,6,4
Data -4,1,9,3,6
Data -5,2,11,11,0
Data 999

Data "LEVEL 7"
Data 1,.25,.25
Data -3,-2,6,1,3
Data -4,-1,8,2,3
Data -5,0,10,4,3
Data -6,1,12,2,1
Data -6,2,12,11,0
Data -6,3,12,13,2
Data -5,4,10,11,1
Data -4,5,8,14,2
Data -3,6,6,1,4
Data 999

Data "LEVEL 8"
Data 1,.25,.25
Data -6,-2,12,1,4
Data -6,-1,12,11,4
Data -6,0,12,2,3
Data -3,1,6,5,1
Data -3,2,6,6,7
Data -3,3,6,7,6
Data -6,4,12,1,0
Data -6,5,12,11,3
Data -6,6,12,13,3
Data 999

Data "LEVEL 9"
Data 1,.25,.25
Data -5,-2,11,1,3
Data -5,-1,11,4,3
Data -5,0,11,7,3
Data -5,1,11,1,3
Data -5,2,11,4,3
Data -5,3,11,7,3
Data -5,4,11,1,3
Data 999

Data "LEVEL 10"
Data 1,.25,.25
Data -5,-2,11,9,2
Data -4,-1,9,11,6
Data -3,0,7,12,4
Data -2,1,5,17,4
Data -1,2,3,16,2
Data 0,3,1,15,1
Data 999

.highscoredata
Data "ich",1000
Data "ich",950
Data "ich",900
Data "ich",850
Data "ich",800
Data "ich",750
Data "ich",700
Data "ich",650
Data "ich",600
Data "ich",550
Data "...",500