; Ein Demo-Spiel fr Robs BB-Kurs 2 
; www.robsite.de

AppTitle "asteroid"	; das englische Original "Rocktoid" auf http://www.blitzcoder.com
					; ist viel ausfhrlicher kommentiert (es hat sogar ein eigenes "Making of ..."),
					; hat zustzliche Feinheiten und ist allgemeiner programmiert. 

					; Ziel dieser Bearbeitung war, den Code mglichst lesbar zu machen. 
					; Programmier-Konventionen und Speed-Optimierungs-Empfehlungen
					; habe ich deshalb manchmal ignoriert.
					;													Jrgen Cassing

					; email	englisches Original: CCNKrylar@aol.com (Krylar)
					;		diese Eindeutschung: jcassing@talknet.de (Jrgen Cassing)

; die konstanten
;*************************************************************

;allgemeine
Const b	= 800			; k a n n   n a t  r l i c h
Const h =  600			;					g e  n d e r t   w e r d e n

Const MaxSchiffe 	= 7
Const SchiffGas# 	= .03
Const SchiffBremse# = .975
Const SchiffDrehen 	= 20	; => volle umdrehung = mind. 20*36 = 720ms
Const MGfeuerZeit 	= 40000	; 40 sec
Const PanzerZeit 	= 7000	;  7 sec

;Tastatur
Const Links	=203, Rechts =205
Const Oben	=200, Runter =208
Const Leer	= 57
Const Enter	= 28
Const Esc	=  1
Const F1	= 59, F12	 = 88

; die globalen Variablen
;*************************************************************

;Bilder
Global Asteroid_Bild
Global S1_Bild
Global S2_Bild
Global S3_Bild
Global Smiley_Bild

;Animationen
Global Explosion_Anim		; raumschiff
Global ExploGross_Anim
Global ExploKlein_Anim

;Parallaxing-Variable  hinten-mitte-front
Global Sterne1x#, Sterne1y#
Global Sterne2x#, Sterne2y#
Global Sterne3x#, Sterne3y#

;Sound-Variablen
Global Laser_Sound
Global Explosion1_Sound
Global Explosion2_Sound
Global Regeneration_Sound
Global Smiley_Sound
Global Solo_Sound
Global Maschinen_Sound
Global Asteroid_Musik
Global Sound_Kanal

;Variablen fr das Timing
Global Jetzt_0
Global Haupt_0
Global Dreh_0
Global Schuss_0
Global Level_0				; zwischen levels
Global Brut_0
Global Smiley_0				; smiley-zeit null
Global MGfeuer_0			; smiley gerammt
Global Panzer_0				; panzer aktiv

;Variablen fr diverse Spiel-Schalter

Global iGameOver 	= 0
Global iAlleSchiffe = 3
Global iAsteroid 	= 5
Global iLevel 		= 1
Global iLevelFertig = 1
Global iLaserschuss = 0
Global iTreffer 	= 0
Global dQuote# 		= 0
Global iSummePunkte = 0
Global iSchnellFeuer= 250		
Global iMGfeuerAn 	= 0		; 1=smiley-kraft auf raumschiff, 0=nicht
Global iTempo 		= 0		; 1=beschleunigen,	0=nicht
Global iRegeneration= 0
Global iFangmich	= 0
Global iPanzer		= 1
Global debug	= 0
Global schnapp	= 0

;Image Arrays
Dim Array_Normal(36)
Dim Array_Panzer(36)
Dim Array_Tempo1(36)
Dim Array_Tempo2(36)
Dim Array_Smiley1(36)
Dim Array_Smiley2(36)
Dim Array_smTempo1(36)
Dim Array_smTempo2(36)
Dim Array_Laser(36)
Dim Array_Aster1(36)
Dim Array_Aster2(36)


;Physik-Tafel arrays
Dim xSin#(36)				; SIN/COS
Dim yCos#(36)
Dim xMax#(36)				; SpeedMax =f(richtung)
Dim yMax#(36)
Dim x90G# (9)				; werte um TABELLESPEEDMAX zu berechnen
Dim y90G# (9)


; die Types
;*************************************************************

; Raumschiff bauen
Type Raumschiff
	Field iRi,X#,Y#,Vx#,Vy#	
	Field dGas#
	Field dBremse#
	Field iLeben			; 1=okay,	0=getroffen
End Type

; Laser
Type Laser
	Field iRi,X#,Y#,Vx#,Vy#	
End Type

; Asteroid
Type Asteroid
	Field iRi,X#,Y#,Vx#,Vy#,iStart,iUhr	
	Field iLevel			; 1=klein,	0=gross
	Field iTyp				; 1=zerteilbar,	0=nicht
	Field iNr				; die frame-nr in der animation
End Type

; Explosion
Type Explosion
	Field     X#,Y#,		iStart,iUhr
	Field iTyp				; 0=raumschiff,1=gross,2=klein
	Field iNr				; die frame-nr in der animation
End Type

; Smiley
Type Smiley
	Field     X#,Y#,Vx#,Vy#,iStart,iUhr	
End Type

;neues Element vom Typ Raumschiff
Global R.Raumschiff = New Raumschiff


; die Hauptschleife
;*************************************************************

Graphics b, h, 16, 2
SetBuffer BackBuffer()

GRAFIKLADEN()
SOUNDLADEN()

SCHIFFNEU()
TABELLESINUSCOSINUS()
TABELLESPEEDMAX()
PICASSOZEIGEN()
UHRENNULL()


While Not KeyDown(Esc)

; Cls
 Jetzt_0=MilliSecs()

 STERNERENDERN()

 If iGameOver 	 = 1 Then  SPIELNEUSTART()
 
 PANZERCHECK()
 SMILEYCHECK()

 If iLevelFertig = 1 Then: LEVELNEUSTART()
 					 Else: SZENERENDERN()		;auf Spanne 25 (= 40fps) bremsen
 EndIf

 RESTZEIGEN()

 PUNKTEZEIGEN()

 If schnapp=1 Then SaveBuffer (BackBuffer(),"schnappschuss.bmp"):schnapp = 0	; F12

 Flip

Wend

StopChannel Asteroid_Musik

Delete R

End





;***************************BB-Hilfe:****************************************
;* F u n k t i o n e n		"most professional programmers loathe and hate <-- verabscheuen und hassen
;*							the use of 'branching' commands like Goto/Gosub"*
;****************************************************************************




; zeichnet die Bilder auf den Schirm und ruft TASTENCHECK()
;*************************************************************
Function SZENERENDERN()

 If Jetzt_0 - Haupt_0 > 25			; wenn der rechner verdammt schnell ist
	Spanne=(Jetzt_0 - Haupt_0)/25	; verlangsamen! - 40 fps (1000/40=25 millisec)
	For k=1 To Spanne
		ASTERFAHRT()
		LASERFAHRT()
		SMILEYFAHRT()
		EXPLOSIONGO()
		If R\iLeben = 1
			TASTENCHECK()
			SCHIFFAHRT()
		EndIf
	Next

	Haupt_0 = Haupt_0 + Spanne*25

 Else								; rechner lahm
	ASTERFAHRT()
	LASERFAHRT()
	SMILEYFAHRT()
	EXPLOSIONGO()
	If R\iLeben = 1
		TASTENCHECK()
		SCHIFFAHRT()
	EndIf

	Haupt_0 = Jetzt_0
 EndIf

 If R\iLeben = 0
	Text b/2, h/2, "Ich zaubere Dir ein neues Raumschiff !",1,1
	affe_0 = MilliSecs()
	If affe_0  - Brut_0 > 2000 And iRegeneration = 0
		PlaySound (Regeneration_Sound)
		iRegeneration = 1
	EndIf

	If affe_0  - Brut_0 > 4500
		iPanzer = 1
		Panzer_0 = MilliSecs()
		SCHIFFNEU()

	EndIf

	iSchnellFeuer = 250
	iMGfeuerAn = 0
	iFangmich = 0
	Smiley_0=MilliSecs()		; smiley-zeit null
 EndIf

 If iPanzer = 1
	Color 0,0,255:	Text 5,.03*h   , "F1  = debug"  
	 				Text 5,.03*h+16, "F12 = Foto ":	Color 255,0,0  
 End If

End Function


; fertig + neu
;*************************************************************
Function LEVELFERTIG(iAsteroid)

 For A.Asteroid		= Each Asteroid:    Delete A: Next
 For L.Laser		= Each Laser:       Delete L: Next
 For E.Explosion	= Each Explosion:   Delete E: Next
 For S.Smiley		= Each Smiley:      Delete S: Next

 For i=0 To iAsteroid:        ASTERNEU():      Next

End Function


; ein paar resets + SCHIFFNEU() + LEVELFERTIG()
;*************************************************************
Function LEVELNEUSTART()

 affe_0 = MilliSecs()
 If affe_0 - Level_0 > 4500

	iPanzer 	 = 1
	Panzer_0 = MilliSecs()
	iLevelFertig = 0
	iLaserschuss = 0
	iTreffer	 = 0
	dQuote#		 = 0
	LEVELFERTIG(iAsteroid)
	iAsteroid = iAsteroid + 5	; mehr asteroiden beim nchsten mal
	SCHIFFNEU()
	UHRENNULL()
 Else
	Color 255,0, 0
	If iLaserschuss > 0 Then
		dQuote# = 100 * iTreffer/iLaserschuss
		Text b/2, h/2-32, "abgefeuerte Laser  = "+iLaserschuss,1,1
		Text b/2, h/2-16, "Trefferzahl          = "+iTreffer,1,1
		Text b/2, h/2,    "Treffer-Durchschnitt = "+Int(dQuote#) +"%",1,1
	EndIf
		Text b/2, 5*h/6,  "Gleich geht's los mit Level "+iLevel,1,1
 EndIf
End Function


; reset und restart
;*************************************************************
Function SPIELNEUSTART()

 iPanzer 		= 1
 iMGfeuerAn 	= 0
 iSchnellFeuer 	= 250
 iFangmich	 	= 0
 iLevelFertig 	= 1
 iAlleSchiffe 	= 3
 iLevel 		= 1
 iAsteroid 		= 5
 LEVELFERTIG(iAsteroid)

 Text b/2, h/2 + 16, "Schlusspunkte: "+iSummePunkte+" -- weiter = Enter ...",1,1
 iSummePunkte 	= 0
 Flip

 While Not KeyHit(Enter)

 Wend
 Cls

 iGameOver = 0
 UHRENNULL()
End Function


; Raumschiff auf den Bildschirm setzen
;*************************************************************
Function SCHIFFNEU()

 R\iRi		= 0
 R\X		= b/2 					; start in bildschirmmitte - REM: AutoMidHandle fr alle grafiken
 R\Y		= h/2 
 R\Vx		= 0
 R\Vy		= 0
 R\dGas		= SchiffGas#
 R\dBremse	= SchiffBremse#
 R\iLeben	= 1

End Function


; tasten checken
;*************************************************************
Function TASTENCHECK()

 If KeyHit (F1) Then debug = Not debug
 If debug=1 Then DEBUGINHALT()


 If KeyDown(F12) Then FlushKeys:	schnapp = 1


 If KeyDown(Leer) Then				; schuss
	affe_0 		= MilliSecs()
	If affe_0 - Schuss_0 > iSchnellFeuer Then
		Schuss_0= MilliSecs()
		LASERNEU(R\X, R\Y, R\iRi)
	EndIf
 EndIf

 If KeyDown(Rechts)  Then
	If Jetzt_0 - Dreh_0 > SchiffDrehen Then;mit welcher geschwindigkeit kann das raumschiff drehen?
		Dreh_0 	= MilliSecs()
		R\iRi = R\iRi + 1:	If R\iRi > 35 Then R\iRi =  0
	 EndIf
 EndIf

 If KeyDown(Links) Then
	If Jetzt_0 - Dreh_0 > SchiffDrehen Then;mit welcher geschwindigkeit kann das raumschiff drehen?
		Dreh_0 	= MilliSecs()
		R\iRi = R\iRi - 1:	If R\iRi <  0 Then R\iRi = 35
	EndIf
 EndIf

 If KeyDown(Oben) Then
	If ChannelPlaying(Sound_Kanal) <> True 	Then Sound_Kanal = PlaySound(Maschinen_Sound)
	iTempo = 1
						R\Vx# = R\Vx# + xSin#(R\iRi) * R\dGas#
						R\Vy# = R\Vy# + yCos#(R\iRi) * R\dGas#
	
	;	  32....0.....4
	;	31				5
	;	 .	   Flug		.
	;	 .   Richtung: 	.          
	;	 .	   der		. 
	;	27	   36er		9 	
	;	 .	 Einheits	.	  
	;	 .	  Kreis		.	
	;	 .				.    
	;	23		 	   13
	;	  22....18...14

	If R\iRi < 9 Then					; 1. quadrant oben rechts

		If R\Vx# < - xMax#(R\iRi) Then

		  If R\iRi < 5:	R\Vx# = R\Vx# - xSin#( 5   ) * R\dGas#				;  0... 4 ->  5= 50(ca 45)
		  Else			R\Vx# = R\Vx# - xSin#(R\iRi) * R\dGas#:EndIf:EndIf	; sonst normale reduktion 

		If R\Vy# >   yMax#(R\iRi) Then

		  If R\iRi > 4:	R\Vy# = R\Vy# - yCos#( 5   ) * R\dGas#				;  5... 8 ->  5= 50(ca 45)
		  Else			R\Vy# = R\Vy# - yCos#(R\iRi) * R\dGas#:EndIf:EndIf	; sonst normale reduktion
	EndIf


	If R\iRi >= 9 And R\iRi < 18 Then	; 2. quadrant unten rechts

		If R\Vy# < - yMax#(R\iRi) Then

		  If R\iRi < 14:R\Vy# = R\Vy# - yCos#(14   ) * R\dGas#				;  9...13 -> 14=140(ca135)
		  Else			R\Vy# = R\Vy# - yCos#(R\iRi) * R\dGas#:EndIf:EndIf	; sonst normale reduktion

		If R\Vx# < - xMax#(R\iRi) Then

		  If R\iRi > 13:R\Vx# = R\Vx# - xSin#(14   ) * R\dGas#				; 14...17 -> 14=140(ca135)
		  Else			R\Vx# = R\Vx# - xSin#(R\iRi) * R\dGas#:EndIf:EndIf	; sonst normale reduktion
	EndIf


	If R\iRi >= 18 And R\iRi < 27 Then	; 3. quadrant unten links

		If R\Vx# >   xMax#(R\iRi) Then

		  If R\iRi < 23:R\Vx# = R\Vx# - xSin#(23   ) * R\dGas#				; 18...22 -> 23=230(ca225)
		  Else			R\Vx# = R\Vx# - xSin#(R\iRi) * R\dGas#:EndIf:EndIf	; sonst normale reduktion

		If R\Vy# < - yMax#(R\iRi) Then

		  If R\iRi > 22:R\Vy# = R\Vy# - yCos#(23   ) * R\dGas#				; 23...26 -> 23=230(ca225)
		  Else			R\Vy# = R\Vy# - yCos#(R\iRi) * R\dGas#:EndIf:EndIf	; sonst normale reduktion
	EndIf


	If R\iRi >= 27 Then					; 4. quadrant oben links

		If R\Vy# >   yMax#(R\iRi) Then

		  If R\iRi < 32:R\Vy# = R\Vy# - yCos#(32   ) * R\dGas#				; 27...31 -> 32=320(ca315)
		  Else			R\Vy# = R\Vy# - yCos#(R\iRi) * R\dGas#:EndIf:EndIf	; sonst normale reduktion

		If R\Vx# >   xMax#(R\iRi) Then

		  If R\iRi > 31:R\Vx# = R\Vx# - xSin#(32   ) * R\dGas#				; 32...35 -> 32=320(ca315)
		  Else			R\Vx# = R\Vx# - xSin#(R\iRi) * R\dGas#:EndIf:EndIf	; sonst normale reduktion
	EndIf
 Else
	iTempo = 0
 EndIf



 If KeyDown(Runter) Then
	
	R\Vx = R\Vx * R\dBremse
	R\Vy = R\Vy * R\dBremse
	
	If R\Vx < .001 And R\Vx > -.001 Then 	R\Vx = 0
	If R\Vy < .001 And R\Vy > -.001 Then	R\Vy = 0
	
 EndIf


End Function



; Panzer-Status        1 = unverwundbar
;*************************************************************
Function PANZERCHECK()
 If iPanzer = 1 Then
	If Jetzt_0 - Panzer_0 > PanzerZeit Then PlaySound Solo_Sound : iPanzer=0
 EndIf
End Function


; hlt das Raumschiff auf dem Schirm
;*************************************************************
Function SCHIFFAHRT()

 iKollision = 0

 R\X = R\X - R\Vx
  
; original-fans machen:	If  > b Then 0	(keine speed-nderung)
;						If  < 0 Then b			usw			  
 If R\X > .99 * b 	Then 	R\X = .99 * b:	R\Vx= -.5 * R\Vx
 If R\X < .01 * b 	Then  	R\X = .01 * b:	R\Vx= -.5 * R\Vx

 R\Y = R\Y - R\Vy
 
 If R\Y > .99 * h  	Then    R\Y = .99 * h:	R\Vy= -.5 * R\Vy
 If R\Y < .01 * h 	Then    R\Y = .01 * h:	R\Vy= -.5 * R\Vy


 If iPanzer = 0 Then
	For A.Asteroid = Each Asteroid
;   - - - - - - - - - - - - - - - -
		If A\iLevel = 1

			If ImagesCollide(Array_Normal(R\iRi),R\X,R\Y,0,Array_Aster2(A\iNr),A\X,A\Y,0) Then	;kleiner A.

			  PlaySound Explosion1_Sound
			  PlaySound Explosion2_Sound

			  EXPLONEU(A\X,A\Y,0)
			  EXPLONEU(R\X,R\Y,1)

			  Delete A

			  R\iLeben 		= 0
			  Brut_0 	= MilliSecs()
			  iRegeneration	= 0
			  iSummePunkte	= iSummePunkte - 500
			  iAlleSchiffe	= iAlleSchiffe - 1

			  If iAlleSchiffe = 0 Then iGameOver = 1

			EndIf
		Else

			If ImagesCollide(Array_Normal(R\iRi),R\X,R\Y,0,Array_Aster1(A\iNr),A\X,A\Y,0) Then	;grosser A.

			  PlaySound Explosion1_Sound
			  PlaySound Explosion2_Sound

			  EXPLONEU(A\X,A\Y,0)
			  EXPLONEU(R\X,R\Y,1)

			  Delete A

			  R\iLeben		= 0
			  Brut_0		= MilliSecs()
			  iRegeneration	= 0
			  iSummePunkte	= iSummePunkte - 500
			  iAlleSchiffe	= iAlleSchiffe - 1

			  If iAlleSchiffe = 0 Then	iGameOver = 1

			EndIf
		EndIf
	Next
 EndIf


 If R\iLeben = 1 Then
	For S.Smiley = Each Smiley
;   - - - - - - - - - - - - - - - -
		If ImagesCollide(Array_Normal(R\iRi),R\X,R\Y,0,Smiley_Bild,S\X,S\Y,0) Then

			PlaySound Smiley_Sound

			iSchnellFeuer = 100
			iMGfeuerAn 	= 1
			iFangmich	= 1					; 1
			MGfeuer_0 = MilliSecs()			; smiley gerammt

			Delete S
		EndIf
	Next

;   das passende raumschiff-array-bild finden									smiley
 	If iMGfeuerAn = 0 Then	; smiley an bord										  tempo
		If iTempo = 0 Then	;		ohne beschleunigung									 	panzer			
		  If iPanzer = 0 	Then: DrawImage Array_Normal  (R\iRi),R\X,R\Y;			.	.	.
		 					Else: DrawImage Array_Panzer  (R\iRi),R\X,R\Y:EndIf;	.	.	1
		Else				; 		mit tempo
		  If iPanzer = 0 	Then: DrawImage Array_Tempo1  (R\iRi),R\X,R\Y;			.	1	.
		  					Else: DrawImage Array_Tempo2  (R\iRi),R\X,R\Y:EndIf;	.	1	1
		EndIf
	Else					; smiley nein
		If iTempo = 0 Then	; 		ohne beschleunigung
		  If iPanzer = 0 	Then: DrawImage Array_Smiley1 (R\iRi),R\X,R\Y;			1	.	.
		  					Else: DrawImage Array_Smiley2 (R\iRi),R\X,R\Y:EndIf;	1	.	1
		Else				;		mit tempo
		  If iPanzer = 0 	Then: DrawImage Array_smTempo1(R\iRi),R\X,R\Y;			1	1	.
		  					Else: DrawImage Array_smTempo2(R\iRi),R\X,R\Y:EndIf;	1	1	1
		EndIf
	EndIf
 EndIf
End Function



; zeigt die verbleibenden Raumschiffe
;*************************************************************
Function RESTZEIGEN()

 affe = ImageWidth(Array_Normal(0))/2 + 2

 For i=1 To iAlleSchiffe-1
	 DrawImage Array_Normal(0),affe,10
	 affe = affe + ImageWidth(Array_Normal(0)) + 5
 Next

End Function



; die drei Sternenbilder, mit parallaxing wie bei insectoids
;*************************************************************
Function STERNERENDERN()

 Sterne1x=(Sterne1x+.1) Mod ImageHeight( S1_Bild )
 Sterne2x=(Sterne2x+.1) Mod ImageHeight( S1_Bild )
 Sterne3x=(Sterne3x+.1) Mod ImageHeight( S1_Bild )

 Sterne1y=(Sterne1y+.1) Mod ImageHeight( S1_Bild )
 Sterne2y=(Sterne2y+.1) Mod ImageHeight( S1_Bild )
 Sterne3y=(Sterne3y+.1) Mod ImageHeight( S1_Bild )

 TileBlock S1_Bild,Sterne1x*1,Sterne1y*1
 TileImage S2_Bild,Sterne2x*2,Sterne2y*2
 TileImage S3_Bild,Sterne3x*3,Sterne3y*3
End Function


; zeigt die Punkte
;*************************************************************
Function PUNKTEZEIGEN()
 Text b/2-20,16,"Punkte: "+iSummePunkte,1,1
End Function



; was im debug-modus gezeigt wird
;*************************************************************
Function DEBUGINHALT()

 Color 0,128,0
 Text .1*b,.95*h-210, "Richtung " + R\iRi + " = " + R\iRi*10 + ""
 Text .1*b,.95*h-186, "R\X:       " + Left$(Str R\X#,			4)
 Text .1*b,.95*h-170, "R\Y:       " + Left$(Str R\Y#,			4)
 Text .1*b,.95*h-106, "R\Vx:      " + Left$(Str R\Vx#,			4)
 Text .1*b,.95*h- 90, "R\Vy:      " + Left$(Str R\Vy#,			4)
 Text .1*b,.95*h- 66, "Sin(10*Ri):" + Left$(Str Sin (R\iRi*10), 4)
 Text .1*b,.95*h- 50, "Cos(10*Ri):" + Left$(Str Cos (R\iRi*10), 4)
 Text .25*b,.95*h-66, "xSin(Ri):  " + Left$(Str xSin#(R\iRi),	4)
 Text .25*b,.95*h-50, "yCos(Ri):  " + Left$(Str yCos#(R\iRi),	4)
 Text .4*b,.95*h- 66, "xMax(Ri):  " + Left$(Str xMax#(R\iRi),	4)
 Text .4*b,.95*h- 50, "yMax(Ri):  " + Left$(Str yMax#(R\iRi),	4)
 Color 255,0,0
End Function



; neuer asteroid
;*************************************************************
Function ASTERNEU()

 A.Asteroid = New Asteroid

 A\iRi 		= Rnd(0,35)
 A\X		= Rnd(b)
 A\Y		= Rnd(h)
 A\Vx#		= xSin#(A\iRi) * Rnd#(.3,1.5)
 A\Vy#		= yCos#(A\iRi) * Rnd#(.3,1.5)
 A\iNr	 	= Rnd(0,35)					; start-frame = f(zufall)
 A\iStart	= MilliSecs()
 A\iUhr 	= Rnd(50,150)				; frame-animations-geschwindigkeit = f(zufall)
 A\iLevel	= Rnd(0,3)					; zerkleinerbar = f(zufall)
 A\iTyp 	= 0							; gross
End Function


; grosser Asteroid wird in kleine zertrmmert
;*************************************************************
Function ASTERSPLITTER(iX, iY)

 For i=0 To Rnd(0,3)

	A.Asteroid = New Asteroid

	A\iRi 	= Rnd(0,35)
	A\X 	= iX
	A\Y 	= iY
	A\Vx# 	= xSin#(A\iRi) * Rnd#(.5,1.75); im durchschnitt schneller
	A\Vy# 	= yCos#(A\iRi) * Rnd#(.5,1.75);					als die grossen 
	A\iNr 	= Rnd(0,35)					; start-frame = f(zufall)
	A\iStart= MilliSecs()
	A\iUhr 	= Rnd(50,150)				; frame-animations-geschwindigkeit = f(zufall)
	A\iLevel= 1							; nicht zerkleinerbar
	A\iTyp 	= 1							; klein
 Next
End Function


; asteroids-Bewegung
;*************************************************************
Function ASTERFAHRT()

 A.Asteroid = First Asteroid			; noch ein asteroid da?

 If A = Null Then						; nein, level=fertig,  ggf. ein extra-raumschiff
	iLevelFertig = 1
	iLevel = iLevel + 1
	Level_0=MilliSecs()
	iAlleSchiffe = iAlleSchiffe + 1
	If iAlleSchiffe > MaxSchiffe Then AlleSchiffe = MaxSchiffe

 Else

	For A.Asteroid = Each Asteroid

		A\X# = A\X# + A\Vx#
		A\Y# = A\Y# + A\Vy#

		If A\X < -.03 * b Then A\X = 1.03 * b
		If A\X > 1.03 * b Then A\X = -.03 * b
		If A\Y < -.03 * h Then A\Y = 1.03 * h 
		If A\Y > 1.03 * h Then A\Y = -.03 * h 


		affe = MilliSecs()

		If affe - A\iStart > A\iUhr
			A\iNr = A\iNr + 1:	If A\iNr > 35 Then	A\iNr = 0
			A\iStart=MilliSecs()
		EndIf

		If A\iTyp = 0	Then:	DrawImage Array_Aster1(A\iNr),A\X,A\Y
						Else:	DrawImage Array_Aster2(A\iNr),A\X,A\Y:	EndIf
	Next
 EndIf
End Function


; Laserbewegung
;*************************************************************
Function LASERNEU(iX, iY, iRi)

 PlaySound Laser_Sound

 L.Laser = New Laser

 L\iRi	= R\iRi
 L\X	= R\X							; startpunkt = mitte des raumschiffs
 L\Y	= R\Y
 L\Vx#	= xSin#(L\iRi) * (3 + 1)		; =f(raumschiff-v, aber schneller)
 L\Vy#	= yCos#(L\iRi) * (3 + 1)

 iLaserschuss = iLaserschuss + 1
End Function


; Laserbewegung,  Kollisionscheck, RandKill
;*************************************************************
Function LASERFAHRT()

 For L.Laser = Each Laser

	L\X# = L\X# - L\Vx#
	L\Y# = L\Y# - L\Vy#

	iKollision = 0

	For A.Asteroid = Each Asteroid

		If A\iLevel = 1 Then

			If ImagesCollide(Array_Laser(L\iRi),L\X,L\Y,0,Array_Aster2(A\iNr),A\X,A\Y,0) Then	;kleiner A.

				iTreffer = iTreffer + 1
				iSummePunkte = iSummePunkte + 100

				PlaySound Explosion2_Sound

				EXPLONEU(L\X,L\Y,0)

				Delete A
				Delete L

				iKollision = 1

				Exit
			EndIf

		Else

			If ImagesCollide(Array_Laser(L\iRi),L\X,L\Y,0,Array_Aster1(A\iNr),A\X,A\Y,0) Then	;grosser A.

				iTreffer = iTreffer + 1
				iSummePunkte = iSummePunkte + 100

				PlaySound Explosion2_Sound

				EXPLONEU(L\X,L\Y,2)

				ASTERSPLITTER(A\X,A\Y)

				Delete A
				Delete L

				iKollision = 1

				Exit
			EndIf
		EndIf
	Next


	If iKollision = 0 Then

		If L\X < 0 Or L\X > b Or L\Y < 0 Or L\Y > h	Then: Delete L
													Else: DrawImage Array_Laser(L\iRi),L\X,L\Y:	EndIf
	EndIf
 Next
End Function


; Smiley                      Schnellfeuer beim Rammen 
;*************************************************************
Function SMILEYCHECK()

 If iFangmich = 0 Then

	If Jetzt_0 - Smiley_0 > 10000

		If Rnd(1,100) > 55 Then:	SMILEYNEU()
									iFangmich=1:	End If
	EndIf
 EndIf


 If iMGfeuerAn = 1 Then

	If Jetzt_0 - Smiley_0 > MGfeuerZeit
		PlaySound Solo_Sound
		iSchnellFeuer = 250
		iMGfeuerAn = 0
		iFangmich = 0
		Smiley_0= MilliSecs()				; smiley-zeit null
	EndIf
 EndIf
End Function



; Smiley noch zuflliger
;*************************************************************
Function SMILEYNEU()

 A.Asteroid = First Asteroid

 If A <> Null Then

	S.Smiley = New Smiley

	S\X		= Rnd(b)
	S\Y		= Rnd(h)
	S\Vx#	= xSin#(A\iRi) * 1.5
	S\Vy#	= yCos#(A\iRi) * 1.3		
	S\iStart= MilliSecs()
	S\iUhr	= Rnd(10000,20000)
 EndIf
End Function


; Smiley haut langsam ab
;*************************************************************
Function SMILEYFAHRT()

 For S.Smiley = Each Smiley

	S\X# = S\X# + S\Vx#
	S\Y# = S\Y# + S\Vy#

	If S\X <   -20	Then S\X = b +20
	If S\X > b +20	Then S\X =	 -20
	If S\Y <   -20	Then S\Y = h +20
	If S\Y > h +20	Then S\Y =	 -20

	DrawImage Smiley_Bild,S\X,S\Y
	
	affe_0  = MilliSecs()

	If affe_0 - S\iStart < 5000		Then	Color 255,0,0: Text S\X+5,S\Y-15, "fang mich doch..."
	If affe_0 - S\iStart > S\iUhr 	Then	Delete S
 Next
End Function


; Explosion = f(position und type).
;*************************************************************
Function EXPLONEU(iX, iY, iTyp)

 E.Explosion = New Explosion

 E\X 	= iX
 E\Y 	= iY
 E\iTyp = iTyp
 E\iNr 	= 0
 E\iStart= MilliSecs()
 E\iUhr = 30
End Function


; Explosion schn
;*************************************************************
Function EXPLOSIONGO()

 For E.Explosion = Each Explosion
	affe  		= MilliSecs()

	If affe - E\iStart > E\iUhr Then

		E\iNr=E\iNr+1
		E\iStart = MilliSecs()

		If 	   E\iTyp = 0 Then
				If E\iNr>4 	Then:	Delete E
							Else:	DrawImage Explosion_Anim ,E\X,E\Y,E\iNr:	EndIf
		Else
			If E\iTyp = 1 Then
				If E\iNr>5	Then:	Delete E
							Else:	DrawImage ExploGross_Anim,E\X,E\Y,E\iNr:	EndIf
			Else
				If E\iNr>3	Then:	Delete E
							Else:	DrawImage ExploKlein_Anim,E\X,E\Y,E\iNr:	EndIf
			EndIf
		EndIf
	EndIf
 Next
End Function




; ldt all die graphiken und animationen.
;*************************************************************
Function GRAFIKLADEN()
 Local Gr   

 AutoMidHandle True

 S1_Bild=LoadImage	( "sterne3.bmp" )
 S2_Bild=LoadImage	( "sterne2.bmp" )
 S3_Bild=LoadImage	( "sterne1.bmp" )

 Gr=LoadImage( "schiff1.bmp" 	):	MaskImage Gr,0,0,0: For n=0 To 35: Array_Normal(n)  =CopyImage(Gr): RotateImage Array_Normal  (n),n*10: Next
 Gr=LoadImage( "schiff2.bmp" 	):	MaskImage Gr,0,0,0: For n=0 To 35: Array_Panzer(n)  =CopyImage(Gr): RotateImage Array_Panzer  (n),n*10: Next
 Gr=LoadImage( "schiff1tempo.bmp" ):MaskImage Gr,0,0,0: For n=0 To 35: Array_Tempo1(n)  =CopyImage(Gr): RotateImage Array_Tempo1  (n),n*10: Next
 Gr=LoadImage( "schiff2tempo.bmp" ):MaskImage Gr,0,0,0: For n=0 To 35: Array_Tempo2(n)  =CopyImage(Gr): RotateImage Array_Tempo2  (n),n*10: Next
 Gr=LoadImage( "schiff1smile.bmp" ):MaskImage Gr,0,0,0: For n=0 To 35: Array_Smiley1(n) =CopyImage(Gr): RotateImage Array_Smiley1 (n),n*10: Next
 Gr=LoadImage( "schiff2smile.bmp" ):MaskImage Gr,0,0,0: For n=0 To 35: Array_Smiley2(n) =CopyImage(Gr): RotateImage Array_Smiley2 (n),n*10: Next
 Gr=LoadImage("schiff1smtempo.bmp"):MaskImage Gr,0,0,0: For n=0 To 35: Array_smTempo1(n)=CopyImage(Gr): RotateImage Array_smTempo1(n),n*10: Next
 Gr=LoadImage("schiff2smtempo.bmp"):MaskImage Gr,0,0,0: For n=0 To 35: Array_smTempo2(n)=CopyImage(Gr): RotateImage Array_smTempo2(n),n*10: Next
 Gr=LoadImage( "laser.bmp"		):	MaskImage Gr,0,0,0: For n=0 To 35: Array_Laser(n)   =CopyImage(Gr): RotateImage Array_Laser   (n),n*10: Next
 Gr=LoadImage( "asteroid1.bmp"	):	MaskImage Gr,0,0,0: For n=0 To 35: Array_Aster1(n)  =CopyImage(Gr): RotateImage Array_Aster1  (n),n*10: Next
 Gr=LoadImage( "asteroid2.bmp"	):	MaskImage Gr,0,0,0: For n=0 To 35: Array_Aster2(n)  =CopyImage(Gr): RotateImage Array_Aster2  (n),n*10: Next

 Smiley_Bild   	=LoadImage    ( "smiley.bmp")
 Asteroid_Bild 	=LoadImage    ( "asteroid0.bmp")

 Explosion_Anim =LoadAnimImage( "explosion1.bmp",32,32,0,5 )
 ExploGross_Anim=LoadAnimImage( "explosion2.bmp",64,46,0,6 )
 ExploKlein_Anim=LoadAnimImage( "explosion3.bmp",18,22,0,4)

End Function


; ldt die sounds
;*************************************************************
Function SOUNDLADEN()
 Laser_Sound		= LoadSound("laser.wav")
 Explosion1_Sound	= LoadSound("explosion1.wav")
 Explosion2_Sound	= LoadSound("explosion2.wav")
 Regeneration_Sound	= LoadSound("regeneration.wav")
 Smiley_Sound 		= LoadSound("smiley.wav")
 Solo_Sound 		= LoadSound("solo.wav")
 Maschinen_Sound 	= LoadSound("maschine.wav")

 Asteroid_Musik 	= PlayMusic("matrix.mid")
End Function



; zeit ist ab jetzt
;*************************************************************
Function UHRENNULL()
 Dreh_0		= MilliSecs()
 Schuss_0	= MilliSecs()
 Haupt_0	= MilliSecs()
 Level_0	= MilliSecs()
 If iMGfeuerAn = 0 Then Smiley_0 = MilliSecs()	; smiley-zeit null
 MGfeuer_0	= MilliSecs()						; smiley gerammt
 Panzer_0	= MilliSecs()
End Function



; SIN/COS tabellen
;*************************************************************
Function TABELLESINUSCOSINUS()
 Local affe# = 0
 
 For affe = 0 To 35					; luft durch den ganzen kreis, mit sin und cos in 10-schritten
	 xSin#(affe) = -Sin(affe*10)
	 yCos#(affe) =  Cos(affe*10)
 Next
End Function



; errechnet die Top speeds fr alle Richtungen
;*************************************************************
Function TABELLESPEEDMAX();					0/-3

 Local vm# = 3;  speed-max
 Local iX = 9;						-3/0			3/0
 Local iY = 0

 For xy = 0 To 9		;					0/ 3
	; speed =f(winkel)				
	x90G#(iX) = vm#	: iX = iX - 1	; (9) ... (0)	=	3.00 ... 0.00
	y90G#(iY) = vm#	: iY = iY + 1	; (0) ... (9)	=	3.00 ... 0.00

	vm# = Abs(vm# - 0.333):	If vm# < .01 Then vm# = .000000
 Next

	; Jetzt die speed-max-Tabellen laden. 
 	doof = 0
 For affe = 0 To 8;   			   0 ...  80
		xMax#(affe) = x90G#(doof);	0.00 0.33 0.67 1.00 1.33 1.67 2.00 2.33 2.67
		yMax#(affe) = y90G#(doof);	3.00 2.67 2.33 2.00 1.67 1.33 1.00 0.67 0.33
	doof = doof + 1;		0..8
 Next

 	doof = 9
 For affe = 9 To 17;			  90 ... 170
		xMax#(affe) = x90G#(doof);	3.00 2.67 2.33 2.00 1.67 1.33 1.00 0.67 0.33 
		yMax#(affe) = y90G#(doof);	0.00 0.33 0.67 1.00 1.33 1.67 2.00 2.33 2.67
	doof = doof - 1;		9..1
 Next

 	doof = 0
 For affe = 18 To 26;			 180 ... 260
		xMax#(affe) = x90G#(doof) 
		yMax#(affe) = y90G#(doof);						usw
	doof = doof + 1;		0..8	
 Next

 	doof = 9
 For affe = 27 To 35;			 270 ... 350
		xMax#(affe) = x90G#(doof)
		yMax#(affe) = y90G#(doof);						usw
	doof = doof - 1;		9..1
 Next
End Function



; Anfang 
;*************************************************************
Function PICASSOZEIGEN()

; Cls
 STERNERENDERN()
 DrawImage(Asteroid_Bild, b/2, h/2); AutoMidHandle fr alle grafiken
 Flip

 Picasso_0=MilliSecs()

 While Not KeyHit(57)			;man mu also nicht 4 sec lang warten 
	Jetzt_0=MilliSecs()
	If Jetzt_0 - Picasso_0 > 4000 Then Exit
 Wend
End Function